Index: TOOLS/WATER_BUDGET/nemo.py
===================================================================
--- TOOLS/WATER_BUDGET/nemo.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/nemo.py	(revision 6647)
@@ -1380,41 +1721,45 @@
     vtab_0 = lbc_add (vtab_0 , nperio=nperio, cd_type='V', psgn=psgn)
     ix, ax = __findAxis__ (vtab_0, 'x')
-    iz, az = __findAxis__ (vtab_0, 'z')
-    if action == 'ave'  : 0.5 *      (vtab_0 + np.roll (vtab_0, axis=ix, shift=-1))
-    if action == 'min'  : np.minimum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
-    if action == 'max'  : np.maximum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
-    if action == 'mult' :             vtab_0 * np.roll (vtab_0, axis=ix, shift=-1)
-    ftab = lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
-    
+    kz, az = __findAxis__ (vtab_0, 'z')
+    if ix : 
+        if action == 'ave'  : 0.5 *      (vtab_0 + np.roll (vtab_0, axis=ix, shift=-1))
+        if action == 'min'  : np.minimum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
+        if action == 'max'  : np.maximum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
+        if action == 'mult' :             vtab_0 * np.roll (vtab_0, axis=ix, shift=-1)
+        ftab = lbc_del (ftab  , nperio=nperio, cd_type='F', psgn=psgn)
+    else :
+         ftab = lbc_del (vtab_0, nperio=nperio, cd_type='F', psgn=psgn)
+   
     if mmath == xr :
-        if ax != None : 
+        if ax : 
             ftab = ftab.assign_coords({ax:np.arange(ftab.shape[ix])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            ftab = ftab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim : ftab = ftab.rename( {az:zdim}) 
     return lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def U2F (utab, nperio=None, psgn=-1.0, zdim='depthf', action='ave') :
+def U2F (utab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
     '''Interpolate an array from U grid to F grid i-mean)'''
     mmath = __mmath__ (utab)
     utab_0 = mmath.where ( np.isnan(utab), 0., utab)
     utab_0 = lbc_add (utab_0 , nperio=nperio, cd_type='U', psgn=psgn)
-    iy, ay = __findAxis__ (utab_0, 'y')
-    iz, az = __findAxis__ (utab_0, 'z')
-    if action == 'ave'  :    ftab = 0.5 *      (utab_0 + np.roll (utab_0, axis=iy, shift=-1))
-    if action == 'min'  :    ftab = np.minimum (utab_0 , np.roll (utab_0, axis=iy, shift=-1))
-    if action == 'max'  :    ftab = np.maximum (utab_0 , np.roll (utab_0, axis=iy, shift=-1))
-    if action == 'mult' :    ftab =             utab_0 * np.roll (utab_0, axis=iy, shift=-1)
-    ftab = lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
-
+    jy, ay = __findAxis__ (utab_0, 'y')
+    kz, az = __findAxis__ (utab_0, 'z')
+    if jy : 
+        if action == 'ave'  :    ftab = 0.5 *      (utab_0 + np.roll (utab_0, axis=jy, shift=-1))
+        if action == 'min'  :    ftab = np.minimum (utab_0 , np.roll (utab_0, axis=jy, shift=-1))
+        if action == 'max'  :    ftab = np.maximum (utab_0 , np.roll (utab_0, axis=jy, shift=-1))
+        if action == 'mult' :    ftab =             utab_0 * np.roll (utab_0, axis=jy, shift=-1)
+        ftab = lbc_del (ftab  , nperio=nperio, cd_type='F', psgn=psgn)
+    else :
+        ftab = lbc_del (utab_0, nperio=nperio, cd_type='F', psgn=psgn)
+  
     if mmath == xr :
-        if ay != None : 
-            ftab = ftab.assign_coords({'y':np.arange(ftab.shape[iy])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            ftab = ftab.rename( {az:zdim}) 
+        if ay : 
+            ftab = ftab.assign_coords({'y':np.arange(ftab.shape[jy])+1.})
+        if zdim and az :
+            if az != zdim : ftab = ftab.rename( {az:zdim}) 
     return ftab
 
-#@numba.jit(forceobj=True)
-def F2T (ftab, nperio=None, psgn=1.0, zdim='deptht', action='ave') :
+def F2T (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
     '''Interpolate an array on F grid to T grid (i- and j- means)'''
     mmath = __mmath__ (ftab)
@@ -1424,37 +1769,36 @@
     return lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def T2F (ttab, nperio=None, psgn=1.0, zdim='deptht', action='mean') :
+def T2F (ttab, nperio=None, psgn=1.0, zdim=None, action='mean') :
     '''Interpolate an array on T grid to F grid (i- and j- means)'''
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
     ttab_0 = lbc_add (ttab_0 , nperio=nperio, cd_type='T', psgn=psgn)
-    ftab = T2U(U2F(ttab, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
+    ftab = T2U (U2F (ttab, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
     
     return lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def F2U (ftab, nperio=None, psgn=1.0, zdim='depthu', action='ave') :
+def F2U (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
     '''Interpolate an array on F grid to FUgrid (i-mean)'''
     mmath = __mmath__ (ftab)
     ftab_0 = mmath.where ( np.isnan(ftab), 0., ftab)
     ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
-    iy, ay = __findAxis__ (ftab_0, 'y')
-    iz, az = __findAxis__ (ftab_0, 'z')
-    if action == 'ave'  : utab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=iy, shift=-1))
-    if action == 'min'  : utab = np.minimum (ftab_0 , np.roll (ftab_0, axis=iy, shift=-1))
-    if action == 'max'  : utab = np.maximum (ftab_0 , np.roll (ftab_0, axis=iy, shift=-1))
-    if action == 'mult' : utab =             ftab_0 * np.roll (ftab_0, axis=iy, shift=-1)
-
-    utab = lbc_del (utab, nperio=nperio, cd_type='U', psgn=psgn)
-    
+    jy, ay = __findAxis__ (ftab_0, 'y')
+    kz, az = __findAxis__ (ftab_0, 'z')
+    if jy : 
+        if action == 'ave'  : utab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=jy, shift=-1))
+        if action == 'min'  : utab = np.minimum (ftab_0 , np.roll (ftab_0, axis=jy, shift=-1))
+        if action == 'max'  : utab = np.maximum (ftab_0 , np.roll (ftab_0, axis=jy, shift=-1))
+        if action == 'mult' : utab =             ftab_0 * np.roll (ftab_0, axis=jy, shift=-1)
+        utab = lbc_del (utab  , nperio=nperio, cd_type='U', psgn=psgn)
+    else :
+        utab = lbc_del (ftab_0, nperio=nperio, cd_type='U', psgn=psgn)
+
     if mmath == xr :
-        utab = utab.assign_coords({ay:np.arange(ftab.shape[iy])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            utab = utab.rename( {az:zdim}) 
+        utab = utab.assign_coords({ay:np.arange(ftab.shape[jy])+1.})
+        if zdim and zz :
+            if az != zdim : utab = utab.rename( {az:zdim}) 
     return utab
 
-#@numba.jit(forceobj=True)
-def F2V (ftab, nperio=None, psgn=1.0, zdim='depthv', action='ave') :
+def F2V (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
     '''Interpolate an array from F grid to V grid (i-mean)'''
     mmath = __mmath__ (ftab)
@@ -1462,19 +1806,21 @@
     ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
     ix, ax = __findAxis__ (ftab_0, 'x')
-    iz, az = __findAxis__ (ftab_0, 'z')
-    if action == 'ave'  : vtab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=ix, shift=-1))
-    if action == 'min'  : vtab = np.minimum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
-    if action == 'max'  : vtab = np.maximum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
-    if action == 'mult' : vtab =             ftab_0 * np.roll (ftab_0, axis=ix, shift=-1)
-
-    vtab = lbc_del (vtab, nperio=nperio, cd_type='V', psgn=psgn)
+    kz, az = __findAxis__ (ftab_0, 'z')
+    if ix : 
+        if action == 'ave'  : vtab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=ix, shift=-1))
+        if action == 'min'  : vtab = np.minimum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
+        if action == 'max'  : vtab = np.maximum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
+        if action == 'mult' : vtab =             ftab_0 * np.roll (ftab_0, axis=ix, shift=-1)
+        vtab = lbc_del (vtab  , nperio=nperio, cd_type='V', psgn=psgn)
+    else : 
+        vtab = lbc_del (ftab_0, nperio=nperio, cd_type='V', psgn=psgn)
+
     if mmath == xr :
         vtab = vtab.assign_coords({ax:np.arange(ftab.shape[ix])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            vtab = vtab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim : vtab = vtab.rename( {az:zdim}) 
     return vtab
 
-#@numba.jit(forceobj=True)
-def W2T (wtab, zcoord=None, zdim='deptht', sval=np.nan) :
+def W2T (wtab, zcoord=None, zdim=None, sval=np.nan) :
     '''
     Interpolate an array on W grid to T grid (k-mean)
@@ -1484,14 +1830,17 @@
     wtab_0 = mmath.where ( np.isnan(wtab), 0., wtab)
 
-    iz, az = __findAxis__ (wtab_0, 'z')
-       
-    ttab = 0.5 * ( wtab_0 + np.roll (wtab_0, axis=iz, shift=-1) )
-    
+    kz, az = __findAxis__ (wtab_0, 'z')
+
+    if kz : 
+        ttab = 0.5 * ( wtab_0 + np.roll (wtab_0, axis=kz, shift=-1) )
+    else :
+        ttab = wtab_0
+
     if mmath == xr :
-        ttab[{az:iz}] = sval
-        if zdim != None and iz != None and az != 'olevel' :
-            ttab = ttab.rename ( {az:zdim} )
-        try    : ttab = ttab.assign_coords ( {zdim:zcoord} )
-        except : pass
+        ttab[{az:kz}] = sval
+        if zdim and az :
+            if az != zdim : ttab = ttab.rename ( {az:zdim} )
+        if zcoord is not None :
+            ttab = ttab.assign_coords ( {zdim:zcoord} )
     else :
         ttab[..., -1, :, :] = sval
@@ -1499,6 +1848,5 @@
     return ttab
 
-#@numba.jit(forceobj=True)
-def T2W (ttab, zcoord=None, zdim='depthw', sval=np.nan, extrap_surf=False) :
+def T2W (ttab, zcoord=None, zdim=None, sval=np.nan, extrap_surf=False) :
     '''Interpolate an array from T grid to W grid (k-mean)
     sval is the surface value
@@ -1507,6 +1855,6 @@
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
-    iz, az = __findAxis__ (ttab_0, 'z')
-    wtab = 0.5 * ( ttab_0 + np.roll (ttab_0, axis=iz, shift=1) )
+    kz, az = __findAxis__ (ttab_0, 'z')
+    wtab = 0.5 * ( ttab_0 + np.roll (ttab_0, axis=kz, shift=1) )
 
     if mmath == xr :
@@ -1518,11 +1866,12 @@
 
     if mmath == xr :
-        if zdim != None and iz != None and az != 'olevel' :
-                wtab = wtab.rename ( {az:zdim})
-        if zcoord != None : wtab = wtab.assign_coords ( {zdim:zcoord})
-        else              : ztab = wtab.assign_coords ( {zdim:np.arange(ttab.shape[iz])+1.} )
+        if zdim and az :
+            if az != zdim : wtab = wtab.rename ( {az:zdim})
+        if zcoord is not None :
+            wtab = wtab.assign_coords ( {zdim:zcoord})
+        else :
+            ztab = wtab.assign_coords ( {zdim:np.arange(ttab.shape[kz])+1.} )
     return wtab
 
-#@numba.jit(forceobj=True)
 def fill (ptab, nperio, cd_type='T', npass=1, sval=0.) :
     '''
@@ -1584,8 +1933,7 @@
     return ztab
 
-#@numba.jit(forceobj=True)
 def correct_uv (u, v, lat) :
     '''
-    Correct a Cartopy bug in Orthographic projection
+    Correct a Cartopy bug in orthographic projection
 
     See https://github.com/SciTools/cartopy/issues/1179
@@ -1593,7 +1941,8 @@
     The correction is needed with cartopy <= 0.20
     It seems that version 0.21 will correct the bug (https://github.com/SciTools/cartopy/pull/1926)
+    Later note : the bug is still present in Cartopy 0.22
 
     Inputs :
-       u, v : eastward/nothward components
+       u, v : eastward/northward components
        lat  : latitude of the point (degrees north)
 
@@ -1608,57 +1957,73 @@
     return uc, vc
 
-def msf (v_e1v_e3v, lat1d, depthw) :
+def norm_uv (u, v) :
+    '''
+    Return norm of a 2 components vector
+    '''
+    return np.sqrt (u*u + v*v)
+
+def normalize_uv (u, v) :
+    '''
+    Normalize 2 components vector
+    '''
+    uv = norm_uv (u, v)
+    return u/uv, v/uv
+
+def msf (vv, e1v_e3v, lat1d, depthw) :
     '''
     Computes the meridonal stream function
     First input is meridional_velocity*e1v*e3v
     '''
-    @numba.jit(forceobj=True)
-    def iin (tab, dim) :
-        '''
-        Integrate from the bottom
-        '''
-        result = tab * 0.0
-        nlen = len(tab.coords[dim])
-        for jn in np.arange (nlen-2, 0, -1) :
-            result [{dim:jn}] = result [{dim:jn+1}] - tab [{dim:jn}]
-        result = result.where (result !=0, np.nan)
-        return result
-    
-    zomsf = iin ((v_e1v_e3v).sum (dim='x', keep_attrs=True)*1E-6, dim='depthv')
-    zomsf = zomsf.assign_coords ( {'depthv':depthw.values, 'y':lat1d})
-    zomsf = zomsf.rename ( {'depthv':'depthw', 'y':'lat'})
+ 
+    v_e1v_e3v = vv * e1v_e3v
+    v_e1v_e3v.attrs = vv.attrs
+    
+    ix, ax = __findAxis__ (v_e1v_e3v, 'x')
+    kz, az = __findAxis__ (v_e1v_e3v, 'z')
+    if az == 'olevel' : new_az = 'olevel'
+    else              : new_az = 'depthw'
+
+    zomsf = -v_e1v_e3v.cumsum ( dim=az, keep_attrs=True).sum (dim=ax, keep_attrs=True)*1.E-6
+    zomsf = zomsf - zomsf.isel ( { az:-1} )
+    
+    jy, ay = __findAxis__ (zomsf, 'y' )
+    zomsf = zomsf.assign_coords ( {az:depthw.values, ay:lat1d.values})
+    
+    zomsf = zomsf.rename ( {ay:'lat'})
+    if az != new_az : zomsf = zomsf.rename ( {az:new_az} )
+    zomsf.attrs['standard_name'] = 'Meridional stream function'
     zomsf.attrs['long_name'] = 'Meridional stream function'
-
     zomsf.attrs['units'] = 'Sv'
-    zomsf.depthw.attrs=depthw.attrs
+    zomsf[new_az].attrs  = depthw.attrs
     zomsf.lat.attrs=lat1d.attrs
         
     return zomsf
 
-def bsf (u_e2u_e3u, mask, nperio=None, bsf0=None ) :
+def bsf (uu, e2u_e3u, mask, nperio=None, bsf0=None ) :
     '''
     Computes the barotropic stream function
     First input is zonal_velocity*e2u*e3u
-    bsf0 is the point with bsf=0 (ex: bsf0={'x':5, 'y':120} )
-    '''
-    @numba.jit(forceobj=True)
-    def iin (tab, dim) :
-        '''
-        Integrate from the south
-        '''
-        result = tab * 0.0
-        nlen = len(tab.coords[dim])
-        for jn in np.arange (3, nlen) :
-            result [{dim:jn}] = result [{dim:jn-1}] + tab [{dim:jn}]
-        return result
-    
-    bsf = iin ((u_e2u_e3u).sum(dim='depthu', keep_attrs=True)*1E-6, dim='y')
-    bsf.attrs = u_e2u_e3u.attrs
-    if bsf0 != None :
+    bsf0 is the point with bsf=0 
+    (ex: bsf0={'x':3, 'y':120} for orca2, 
+         bsf0={'x':5, 'y':300} for eeORCA1
+    '''
+    u_e2u_e3u       = uu * e2u_e3u
+    u_e2u_e3u.attrs = uu.attrs
+
+    iy, ay = __findAxis__ (u_e2u_e3u, 'y')
+    kz, az = __findAxis__ (u_e2u_e3u, 'z')
+    
+    bsf = -u_e2u_e3u.cumsum ( dim=ay, keep_attrs=True )
+    bsf = bsf.sum (dim=az, keep_attrs=True)*1.E-6
+        
+    if bsf0 :
         bsf = bsf - bsf.isel (bsf0)
        
     bsf = bsf.where (mask !=0, np.nan)
-    bsf.attrs['long_name'] = 'Barotropic stream function'
-    bsf.attrs['units'] = 'Sv'
+    for attr in uu.attrs :
+        bsf.attrs[attr] = uu.attrs[attr]
+    bsf.attrs['standard_name'] = 'barotropic_stream_function'
+    bsf.attrs['long_name']     = 'Barotropic stream function'
+    bsf.attrs['units']         = 'Sv'
     bsf = lbc (bsf, nperio=nperio, cd_type='F')
        
@@ -1679,10 +2044,11 @@
     
     '''
-
-    if ref != None :
+    
+    import f90nml
+    if ref :
         if isinstance (ref, str) : nml_ref = f90nml.read (ref)
         if isinstance (ref, f90nml.namelist.Namelist) : nml_ref = ref
         
-    if cfg != None :
+    if cfg :
         if isinstance (cfg, str) : nml_cfg = f90nml.read (cfg)
         if isinstance (cfg, f90nml.namelist.Namelist) : nml_cfg = cfg
@@ -1693,8 +2059,6 @@
     list_nml = [] ; list_comment = []
 
-    if ref != None :
-        list_nml.append (nml_ref) ; list_comment.append ('ref')
-    if cfg != None :
-        list_nml.append (nml_cfg) ; list_comment.append ('cfg')
+    if ref : list_nml.append (nml_ref) ; list_comment.append ('ref')
+    if cfg : list_nml.append (nml_cfg) ; list_comment.append ('cfg')
 
     for nml, comment in zip (list_nml, list_comment) :
@@ -1719,5 +2083,4 @@
     if out == 'xr'   : return xr_namelist
 
-
 def fill_closed_seas (imask, nperio=None,  cd_type='T') :
     '''Fill closed seas with image processing library
@@ -1730,4 +2093,71 @@
 
     return imask_filled
+
+'''
+Sea water state function parameters from NEMO code
+'''
+rdeltaS = 32. ; r1_S0  = 0.875/35.16504 ; r1_T0  = 1./40. ; r1_Z0  = 1.e-4
+
+EOS000 =  8.0189615746e+02 ; EOS100 =  8.6672408165e+02 ; EOS200 = -1.7864682637e+03 ; EOS300 =  2.0375295546e+03 ; EOS400 = -1.2849161071e+03 ; EOS500 =  4.3227585684e+02 ; EOS600 = -6.0579916612e+01
+EOS010 =  2.6010145068e+01 ; EOS110 = -6.5281885265e+01 ; EOS210 =  8.1770425108e+01 ; EOS310 = -5.6888046321e+01 ; EOS410 =  1.7681814114e+01 ; EOS510 = -1.9193502195
+EOS020 = -3.7074170417e+01 ; EOS120 =  6.1548258127e+01 ; EOS220 = -6.0362551501e+01 ; EOS320 =  2.9130021253e+01 ; EOS420 = -5.4723692739     ; EOS030 =  2.1661789529e+01 
+EOS130 = -3.3449108469e+01 ; EOS230 =  1.9717078466e+01 ; EOS330 = -3.1742946532
+EOS040 = -8.3627885467     ; EOS140 =  1.1311538584e+01 ; EOS240 = -5.3563304045
+EOS050 =  5.4048723791e-01 ; EOS150 =  4.8169980163e-01
+EOS060 = -1.9083568888e-01
+EOS001 =  1.9681925209e+01 ; EOS101 = -4.2549998214e+01 ; EOS201 =  5.0774768218e+01 ; EOS301 = -3.0938076334e+01 ; EOS401 =   6.6051753097    ; EOS011 = -1.3336301113e+01
+EOS111 = -4.4870114575     ; EOS211 =  5.0042598061     ; EOS311 = -6.5399043664e-01 ; EOS021 =  6.7080479603     ; EOS121 =   3.5063081279
+EOS221 = -1.8795372996     ; EOS031 = -2.4649669534     ; EOS131 = -5.5077101279e-01 ; EOS041 =  5.5927935970e-01
+EOS002 =  2.0660924175     ; EOS102 = -4.9527603989     ; EOS202 =  2.5019633244     ; EOS012 =  2.0564311499     ; EOS112 = -2.1311365518e-01 ; EOS022 = -1.2419983026
+EOS003 = -2.3342758797e-02 ; EOS103 = -1.8507636718e-02 ; EOS013 =  3.7969820455e-01 
+
+def rhop ( ptemp, psal ) :
+    '''
+    Potential density referenced to surface
+    Computation from NEMO code
+    '''
+    zt  = ptemp * r1_T0                                  # Temperature (Â°C)
+    zs  = np.sqrt ( np.abs( psal + rdeltaS ) * r1_S0 )   # Square root of salinity (PSS)
+    #
+    prhop = (((((EOS060*zt   \
+             + EOS150*zs     + EOS050)*zt   \
+             + (EOS240*zs    + EOS140)*zs + EOS040)*zt   \
+             + ((EOS330*zs   + EOS230)*zs + EOS130)*zs + EOS030)*zt   \
+             + (((EOS420*zs  + EOS320)*zs + EOS220)*zs + EOS120)*zs + EOS020)*zt   \
+             + ((((EOS510*zs + EOS410)*zs + EOS310)*zs + EOS210)*zs + EOS110)*zs + EOS010)*zt   \
+             + (((((EOS600*zs+ EOS500)*zs + EOS400)*zs + EOS300)*zs + EOS200)*zs + EOS100)*zs + EOS000
+    #
+    return prhop
+
+def rho ( pdep, ptemp, psal ) :
+    '''
+    In situ density
+    Computation from NEMO code
+    '''
+    zh  = pdep  * r1_Z0                                  # Depth (m)
+    zt  = ptemp * r1_T0                                  # Temperature (Â°C)
+    zs  = np.sqrt ( np.abs( psal + rdeltaS ) * r1_S0 )   # Square root salinity (PSS)
+    #
+    zn3 = EOS013*zt + EOS103*zs+EOS003
+    #
+    zn2 = (EOS022*zt + EOS112*zs+EOS012)*zt + (EOS202*zs+EOS102)*zs+EOS002
+    #
+    zn1 = (((EOS041*zt   \
+         + EOS131*zs   + EOS031)*zt   \
+         + (EOS221*zs  + EOS121)*zs + EOS021)*zt   \
+        + ((EOS311*zs  + EOS211)*zs + EOS111)*zs + EOS011)*zt   \
+        + (((EOS401*zs + EOS301)*zs + EOS201)*zs + EOS101)*zs + EOS001
+    #
+    zn0 = (((((EOS060*zt   \
+             + EOS150*zs      + EOS050)*zt   \
+             + (EOS240*zs     + EOS140)*zs + EOS040)*zt   \
+             + ((EOS330*zs    + EOS230)*zs + EOS130)*zs + EOS030)*zt   \
+             + (((EOS420*zs   + EOS320)*zs + EOS220)*zs + EOS120)*zs + EOS020)*zt   \
+             + ((((EOS510*zs  + EOS410)*zs + EOS310)*zs + EOS210)*zs + EOS110)*zs + EOS010)*zt   \
+             + (((((EOS600*zs + EOS500)*zs + EOS400)*zs + EOS300)*zs + EOS200)*zs + EOS100)*zs + EOS000
+    #
+    prho  = ( ( zn3 * zh + zn2 ) * zh + zn1 ) * zh + zn0
+    #
+    return prho
 
 ## ===========================================================================
